<script>
  function initResultat() {
    // -------
    // Filters
    // -------

    // Filter arg1 = variable ausgangsdatenset, arg2 = fitermodus callback, > returns filtered object
    function filter(from, filterMode) {
      let filtered = [];
      for (let i = 0; i < from.length; i++) {
        filterMode(from, filtered, i);
      }
      console.log(filtered);
      return filtered;
    }

    // Filter Projektionsweg nach Standortsregion
    function filterMode_region(from, filtered, i) {
      let r;
      const reg = readValueURL("region");
      r = from[i].region[reg];
      if (r === true) {
        filtered.push(from[i]);
        console.log(from[i]);
      }
    }

    // Filter nach Vegetatonshöhenstufe Current (current.HS_1)
    function filterMode_VHCurrent(from, filtered, i) {
      if (readValueURL("current") === from[i].vhIst) {
        filtered.push(from[i]);
        console.log(from[i]);
      }
    }

    // Filter nach Vegetatonshöhenstufe mässig (regCM3.HS_1)
    function filterMode_VHregCM3(from, filtered, i) {
      if (readValueURL("regCM3") === from[i].vhNeu) {
        filtered.push(from[i]);
        console.log(from[i]);
      }
    }

    // Filter nach Vegetatonshöhenstufe stark (CLM.HS_1)
    function filterMode_VHCLM(from, filtered, i) {
      if (readValueURL("CLM") === from[i].vhNeu) {
        filtered.push(from[i]);
        console.log(from[i]);
      }
    }

    // Filter nach Waldgesellschaft (wgBund) and return neue projezierte Waldgesellschaft (wgNeu)
    function filterMode_wg(from, filtered, i) {
      if (from[i].wgIst === readValueURL("wgBund")) {
        filtered.push(from[i].wgNeu);
        console.log(from[i].wgNeu);
      }
    }

    // Filtering Data to get to Waldgesellschaft bei Projektion Mässig/RegCM3
    // if: check if vegetationshöhenstufe remains the same in the climate projection
    if (readValueURL("current") === readValueURL("regCM3")) {
      setValueURL("wgRegCM3", readValueURL("wgBund"));
    } else {
      setValueURL(
        "wgRegCM3",
        filter(
          filter(
            filter(
              filter(projektionswege, filterMode_region),
              filterMode_VHCurrent
            ),
            filterMode_VHregCM3
          ),
          filterMode_wg
        )[0]
      );
    }
    console.log("wgRegCM3: " + readValueURL("wgRegCM3"));

    // Filtering Data to get to Waldgesellschaft bei Projektion Stark/CLM
    if (readValueURL("current") === readValueURL("CLM")) {
      setValueURL("wgCLM", readValueURL("wgBund"));
    } else {
        const filter_region = filter(projektionswege, filterMode_region);
        const filter_VHCurrent = filter(filter_region, filterMode_VHCurrent);
        const filter_VHCLM = filter(filter_VHCurrent, filterMode_VHCLM);
        const values = filter(filter_VHCLM, filterMode_wg);
      setValueURL(
        "wgCLM",
        values[0]
      );
    }
    console.log("wgCLM: " + readValueURL("wgCLM"));

    console.log("test" + filter(projektionswege, filterMode_region));

    // Grab the Description/Details of the Waldgesellschaft from var: waldgesellschaften (editor/api/waldgesellschaften)
    function descriptionWG(gesuchteWG) {
      for (i = 0; i < waldgesellschaften.length; i++) {
        if (waldgesellschaften[i].wg === gesuchteWG) {
          return waldgesellschaften[i];
        }
      }
    }

    let wgBunddesc = descriptionWG(readValueURL("wgBund"));
    let wgRegCM3desc = descriptionWG(readValueURL("wgRegCM3"));
    let wgCLMdesc = descriptionWG(readValueURL("wgCLM"));
    console.log("wgRegCM3desc:" + JSON.stringify(wgRegCM3desc));
    console.log("wgCLMdesc: " + JSON.stringify(wgCLMdesc));

    // Check if Projezierte Waldgesellschaften bei RegCM3 und CLM in der gleichen Ergebnis (gleiche Waldgesellschaft) resultieren
    function notsame() {
      if (readValueURL("wgCLM") === readValueURL("wgRegCM3")) {
        return false;
      } else {
        return true;
      }
    }

    // ------
    // Layout
    // ------

    // Build Phrase
    function showProjektion() {
      let layout = `<div class="content">Heute ist an Ihrem Standort die Waldgesellschaft <span class="highlight">${readValueURL(
        "wgBund"
      )}</span> in der Vegetationshöhenstufe <span class="highlight">${readValueURL(
        "current"
      )}</span> vorherrschend. In der Klimamodellierung für 2070 - 2099 wird dies bei einer weniger trockenen Klimaveränderung (RegCM3) zu: <span class="highlight">${readValueURL(
        "wgRegCM3"
      )}</span> in <span class="highlight">${readValueURL(
        "regCM3"
      )}</span>, sowie in der stark trockenen Klimaveränderung (CLM) zu <span class="highlight">${readValueURL(
        "wgCLM"
      )}</span> in <span class="highlight">${readValueURL(
        "CLM"
      )}</span>.</div>`;
      document.getElementById("resultat-desc-item-0-0").innerHTML = layout;
    }
    showProjektion();

    function showWaldgesellschaft(wg, mode) {
        let id;
        for (i = 0; i < waldgesellschaften.length; i++) {
            if (waldgesellschaften[i].wg === wg) {
                id = i;
            }
        }

      if (mode === 0) {
        let layout =
          '<div class="attr-title">Standortsbeschreibung Waldgesellschaft heute</div>';
        const orderDesc = [
          "wald",
          "height",
          "location",
          "dominant",
          "beigemischt",
          "weitere",
          "aspekt",
          "straucher",
          "krauter",
          "bemerkungen",
          "limit",
          "bau"
        ];
        for (i = 0; i < orderDesc.length; i++) {
          if (waldgesellschaften[id].desc[orderDesc[i]]) {
            layout += `<div class="row"><div class="attr"> ${
              schemaWaldgesellschaften.items.properties.desc.properties[
                orderDesc[i]
              ].title
            }</div>`;
            layout += `<div class="content">${
              waldgesellschaften[id].desc[orderDesc[i]]
            }</div></div>`;
          }
        }
        document.getElementById("resultat-desc-item-0-1").innerHTML = layout;
      }

      if (mode === 1) {
        let layout = ""; //`<div class="attr-title">Klimaprognose wenig trocken (RegCM3)</div>`;
        const orderProjektion = ["more", "ok", "less", "achtung"];
        for (i = 0; i < orderProjektion.length; i++) {
          if (waldgesellschaften[id].RegCM3[orderProjektion[i]]) {
            layout += `<div class="row"><div class="attr">${
              schemaWaldgesellschaften.items.properties.RegCM3.properties[
                orderProjektion[i]
              ].title
            }</div>`;
            layout += `<div class="content">${
              waldgesellschaften[id].RegCM3[orderProjektion[i]]
            }</div></div>`;
          }
        }
        document.getElementById("resultat-card-desc-1").innerHTML = layout;
      }

      if (mode === 2) {
        let layout = ""; //`<div class="attr-title">Klimaprognose trocken (CLM)</div>`;
        const orderProjektion = ["more", "ok", "less", "achtung"];
        
        for (i = 0; i < orderProjektion.length; i++) {
          if (waldgesellschaften[id].CLM[orderProjektion[i]]) {
            layout += `<div class="row"><div class="attr">${
              schemaWaldgesellschaften.items.properties.CLM.properties[
                orderProjektion[i]
              ].title
            }</div>`;
            layout += `<div class="content">${
              waldgesellschaften[id].CLM[orderProjektion[i]]
            }</div></div>`;
          }
        }
        document.getElementById("resultat-card-desc-2").innerHTML = layout;
      }
    }

    showWaldgesellschaft(readValueURL("wgBund"), 0);
    showWaldgesellschaft(readValueURL("wgRegCM3"), 1);
    showWaldgesellschaft(readValueURL("wgCLM"), 2);
  }
</script>
